<?
/**
* Class ProjectHelper
* for Project class manipulation
*/
require_once('DB.php');

class ProjectHelper {
	
	/**
	 * Search all projects
	 *
	 * @param unknown $user
	 * @return unknown
	 */
	function findAllProjects($user) {
		$result = array();
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return $result;

  		if ($user->isManager()) {
  			$sel_str = "select p.p_id, p.p_name from projects p, project_status_list psl
  					where p.p_manager_id = ". $user->getUserId() ." and psl.psl_id = p.p_status and psl.psl_hidden = 0 order by p.p_name";
  		} else {
    		$sel_str = "select p.p_id, p.p_name from projects p, project_status_list psl
    				where p.p_manager_id = ". $user->getManagerId() ." and psl.psl_id = p.p_status and psl.psl_hidden = 0 order by p.p_name";
  		}
	
		$db->setFetchMode(DB_FETCHMODE_ASSOC);
  		$sth = $db->prepare($sel_str);
  		$rc = $db->execute($sth);
  		if (DB::isError($rc) == 0) {
    		while ($val = $rc->fetchRow()) {
      			$result[] = $val;
      		}
      		$result = mu_sort($result,"p_name");
  		}
  		
  		return $result;
	}
	
	/**
	 * Find project by his ID
	 *
	 * @param string $user_id
	 * @param string $pr_id
	 * @return array
	 */
	function findProjectById($user_id, $pr_id) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;

		$sel_str = "select p.p_id, p.p_name from projects p, project_status_list psl where p.p_id = $pr_id and p.p_manager_id = $user_id and psl.psl_id = p.p_status and psl.psl_hidden = 0";
  		$db->setFetchMode(DB_FETCHMODE_ASSOC);
		$sth = $db->prepare($sel_str);
  		$rc = $db->execute($sth);

  		if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();
	   		if ($val['p_id'] != '') {
    		  return $val;
    		} else {
      		  return false;
    		}
  		}
    	return false;
	}
	
	/**
	 * Find project by his name
	 *
	 * @param unknown $user_id
	 * @param unknown $pr_name
	 * @return unknown
	 */
	function findProjectByName($user_id, $pr_name) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
  		$sth = $db->prepare("select p.p_id, p.p_name from projects p, project_status_list psl where p.p_name='$pr_name' and p.p_manager_id = $user_id and psl.psl_id = p.p_status and psl.psl_hidden = 0");
		$db->setFetchMode(DB_FETCHMODE_ASSOC);
  		$rc = $db->execute($sth);

  		if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();
	   		if ($val['p_id']!= '') {
    		  return $val;
    		} else {
      		  return false;
    		}
  		}
    	return false;
	}
	
	/**
	 * Update exists project
	 *
	 * @param unknown $user_id
	 * @param unknown $project_id
	 * @param unknown $project_name
	 * @return unknown
	 */
	function update($user_id, $project_id, $project_name) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
  		$hidden_pr = ProjectHelper::getHiddenProject();
  		if ($hidden_pr) {
    		$sth = $db->prepare("update projects set p_name = '!' where p_id = $project_id and p_manager_id = $user_id and p_status <> $hidden_pr");
    		$data = array($project_name);
    		$rc = $db->execute($sth, $data);
    		if (DB::isError($rc) == 0) {
      			return true;
    		}
		}
		return false;
	}
	
	/**
	 * Create new project
	 *
	 * @param unknown $user_id
	 * @param unknown $project_name
	 * @return unknown
	 */
	function insert($user_id, $project_name) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
  		$sth = $db->prepare("insert into projects (p_manager_id, p_name) values ($user_id, '!')");
  		$data = array($project_name);
  		$rc = $db->execute($sth, $data);
  		if (DB::isError($rc) == 0) {
    		return true;
  		}
	    return false;
	}
	
	/**
	 * Delete project
	 *
	 * @param unknown $user_id
	 * @param unknown $project_id
	 * @return unknown
	 */
	function delete($user_id, $project_id) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
  		$hidden_pr = ProjectHelper::getHiddenProject();
  		if ($hidden_pr) {
    		$sth = $db->prepare("update projects set p_status = $hidden_pr where p_id = $project_id and p_manager_id = $user_id");
    		$rc = $db->execute($sth);
    		if (DB::isError($rc) == 0) {
		        return true;
		    }
  		}
	    return false;
	}
	
	/**
	 * ?
	 *
	 * @param int $project_id
	 * @param object $user
	 * @return bool
	 */
	function isProjectExistsStrict($project_id,$user) {
		$result = false;
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$user_id = $user->getManagerId();
    	if ($user->isManager()) $user_id = $user->getUserId();
    		
    	$sel_str = "select count(p.p_id) as prjc
    		from projects p, project_status_list psl
    		where p.p_id = $project_id and p.p_manager_id = ".$user_id." and p.p_status = psl.psl_id and psl.psl_hidden = 0";
    	$db->setFetchMode(DB_FETCHMODE_ASSOC);
  		$sth = $db->prepare($sel_str);
  		$rc = $db->execute($sth);
  		if (DB::isError($rc) == 0) {
    		if ($val = $rc->fetchRow()) {
    			if ($val["prjc"]>0) $result = true;
      		}
  		}
  		
  		return $result;
	}
	
	/**
	 * Check project
	 *
	 * @param unknown $project_id
	 * @return unknown
	 */
	function isProjectExists($project_id) {
		$db = DB::connect(DSN);
    	if (DB::isError($db))
    		return false;
    		
    	$sel_str = "select count(p.p_id) from projects p, project_status_list psl where p.p_id = $project_id and p.p_status = psl.psl_id and psl.psl_hidden = 0";
  		$sth = $db->prepare($sel_str);
  		$rc = $db->execute($sth);

  		if (DB::isError($rc) == 0) {
    		$val = $rc->fetchRow();

    		if ($val[0] > 0) {
      			return true;
    		} else {
      			return false;
    		}
    	}
    	return false;
  }
  
  /**
   * get ID hidden project
   *
   * @return unknown
   */
  function getHiddenProject() {
  	$db = DB::connect(DSN);
    if (DB::isError($db))
    	return false;

  	$sth = $db->prepare("select psl_id from project_status_list where psl_hidden = 1");
  	$rc = $db->execute($sth);

  	if (DB::isError($rc) == 0) {
    	$val = $rc->fetchRow();
    	if ($val[0]) {
      		return $val[0];
    	} else {
      		return false;
    	}
  	}
    return false;
  }
	
}
?>