<?php
// +----------------------------------------------------------------------+
// | WR Time Tracker
// +----------------------------------------------------------------------+
// | Copyright (c) 2004-2005 WR Consulting (http://www.wrconsulting.com)
// +----------------------------------------------------------------------+
// | LIBERAL FREEWARE LICENSE: This source code document may be used
// | by anyone for any purpose, and freely redistributed alone or in
// | combination with other software, provided that the license is obeyed.
// |
// | There are only two ways to violate the license:
// |
// | 1. To redistribute this code in source form, with the copyright
// |    notice or license removed or altered. (Distributing in compiled
// |    forms without embedded copyright notices is permitted).
// |
// | 2. To redistribute modified versions of this code in *any* form
// |    that bears insufficient indications that the modifications are
// |    not the work of the original author(s).
// |
// | This license applies to this document only, not any other software
// | that it may be combined with.
// |
// +----------------------------------------------------------------------+
// | Contributors: Igor Melnik <imelnik@wrconsulting.com>
// +----------------------------------------------------------------------+

	require_once('initialize.php');
	import('form.Form');
	import('form.ActionForm');
	import('DateTime');
	import('UserHelper');
	import('Period');
	import('ProjectHelper');
    import('ActivityHelper');
    
	if ($auth->isAuthenticated()) {
		$user = new User($auth->getUserId());
	} else {
		Header("Location: login.php");
		exit();
	}

    $form = new Form('reportForm');
    $form->setRequest($request);
    $g_user_list = UserHelper::findAllUsers($user);
    foreach ($g_user_list as $user_item) {
    	$user_list[$user_item["u_id"]] = $user_item["u_name"];
    	$users_values[] = $user_item["u_id"];
    }
    $form->addInput(array("type"=>"checkboxgroup","name"=>"users","data"=>$user_list));
	$project_list = ProjectHelper::findAllProjects($user);	
    $form->addInput(array("type"=>"combobox",
    	"onchange"=>"fillActivityDir();",
    	"name"=>"project",
    	"data"=>$project_list,
    	"datakeys"=>array("p_id","p_name"),
    	"empty"=>array(""=>$i18n->getKey('controls.all'))
    	));
 	$activity_list = ActivityHelper::findAllActivity($user);
    $form->addInput(array("type"=>"combobox",
    	"name"=>"activity",
    	"data"=>$activity_list,
    	"datakeys"=>array("a_id","a_name"),
    	"empty"=>array(""=>$i18n->getKey('controls.all'))
    	));
    $form->addInput(array("type"=>"combobox",
    	"name"=>"period",
    	"data"=>array(
    			PERIOD_THIS_MONTH=>$i18n->getKey('controls.per_tm'),
    			PERIOD_LAST_MONTH=>$i18n->getKey('controls.per_lm'),
    			PERIOD_THIS_WEEK=>$i18n->getKey('controls.per_tw'),
    			PERIOD_LAST_WEEK=>$i18n->getKey('controls.per_lw')),
    	"empty"=>array(""=>$i18n->getKey('controls.sel_period'))
    	));
    	
    if ($user->isManager())
    	$groupby_data = array("user"=>$i18n->getKey('form.report.groupby_user'));
    $groupby_data["project"]=$i18n->getKey('form.report.groupby_project');
    $groupby_data["activity"]=$i18n->getKey('form.report.groupby_activity');
    
    $form->addInput(array("type"=>"datetext","maxlength"=>"20","name"=>"from"));
    $form->addInput(array("type"=>"datetext","maxlength"=>"20","name"=>"to"));
    $form->addInput(array("type"=>"combobox",
    	"name"=>"groupby",
    	"data"=>$groupby_data,
    	"empty"=>array(""=>$i18n->getKey('controls.sel_groupby'))
    	));
    $form->addInput(array("type"=>"checkbox","name"=>"chproject","data"=>1));
    $form->addInput(array("type"=>"checkbox","name"=>"chactivity","data"=>1));
    $form->addInput(array("type"=>"checkbox","name"=>"chstart","data"=>1));
    $form->addInput(array("type"=>"checkbox","name"=>"chfinish","data"=>1));
    $form->addInput(array("type"=>"checkbox","name"=>"chduration","data"=>1));
    $form->addInput(array("type"=>"checkbox","name"=>"chnote","data"=>1));
    $form->addInput(array("type"=>"checkbox","name"=>"chshowidle","data"=>1));
	$form->addInput(array("type"=>"submit","name"=>"btsubmit"));

	$bean = new ActionForm("reportBean", $form, $request);
	$form->setValueByElement("btsubmit",$i18n->getKey('button.generate'));

	if ($request->getMethod()=="POST") {
		if (!$bean->getAttribute("period")) {
			$o_from = new DateTime($i18n->getDateFormat(),$bean->getAttribute("from"));
			if ($o_from->isError() || !$bean->getAttribute("from") )
				$errors->add("datefrom",$i18n->getKey("errors.wrong"),$i18n->getKey("form.report.from"));
				
			$o_to = new DateTime($i18n->getDateFormat(),$bean->getAttribute("to"));
			if ($o_to->isError() || !$bean->getAttribute("to"))
				$errors->add("dateto",$i18n->getKey("errors.wrong"),$i18n->getKey("form.report.to"));
			
			if ($o_from->compare($o_to)>0)
				$errors->add("period",$i18n->getKey("errors.report_period"));
		}
		$bean->saveBean();
		
        if ($errors->isEmpty()) {
        	header("Location: report_table.php");
        }
	}
	
	if (!$bean->isSaved()) { // stored in session
    	$form->setValueByElement("users", $users_values);
    	
    	$period		= new Period(PERIOD_THIS_MONTH, new DateTime($i18n->getDateFormat()));
		$form->setValueByElement("from", $period->getBeginDate() );
		$form->setValueByElement("to", $period->getEndDate() );
		
		$form->setValueByElement("chproject", 1);
		$form->setValueByElement("chactivity", 1);
		$form->setValueByElement("chstart", 1);
		$form->setValueByElement("chfinish", 1);
		$form->setValueByElement("chduration", 1);
		$form->setValueByElement("chnote", 1);
		$form->setValueByElement("chshowidle", 0);
    }
	
	if (!$errors->isEmpty()) {
		$smarty->assign("errors", $errors->getErrors() );
	}
	$smarty->assign("activity_list", $activity_list );
	$smarty->assign("forms",array($form->getName()=>$form->toArray()));
	$smarty->assign("userdet_string",UserHelper::getUserDetailsString($user,$GLOBALS["I18N"]));
    $smarty->assign("onload","onLoad=\"document.reportForm.project.focus();fillActivityDir();\"");
    $smarty->assign("title_page",$i18n->getKey("form.report.title"));
  	$smarty->assign("content_page_name", "report_filter.tpl");
  	$smarty->display(INDEX_TEMPLATE);
?>